"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

var _child_process = require("child_process");

var _package = require("../../package.json");

var _configYml = _interopRequireDefault(require("config-yml"));

var _server = _interopRequireDefault(require("./server"));

var _zeromq = _interopRequireDefault(require("zeromq"));

var _configureStore = _interopRequireDefault(require("./store/configureStore"));

var appInfo = _interopRequireWildcard(require("./actions/appInfo"));

var zmqBroker = _interopRequireWildcard(require("./actions/zmqBroker"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

console.log(_package.name + " " + _package.version);
var url_init = "tcp://" + _configYml["default"].discovery.input.host + ":" + _configYml["default"].discovery.input.port;
var url_publisher = "tcp://" + _configYml["default"].discovery.publish.host + ":" + _configYml["default"].discovery.publish.port;

var zmq_discovery_init = _zeromq["default"].socket("req");

var zmq_discovery = _zeromq["default"].socket("sub");

if (url_init !== undefined && url_init !== 0) {
  console.log("ZMQ connected to " + url_init);
  zmq_discovery_init.connect(url_init);
  zmq_discovery_init.send(["get", "", "", ""]);
  zmq_discovery_init.on("message", function (data) {
    var dataObj = JSON.parse(data.toString());
    dataObj.data.forEach(function (item) {
      console.log(item);

      _configureStore["default"].dispatch(zmqBroker.onZeroMQAdd(item, _server["default"].wss));
    });
    zmq_discovery_init.disconnect(url_init);
  });
}

if (url_publisher !== undefined && url_publisher.length !== 0) {
  console.log("ZMQ connected to " + url_publisher + " sub='" + _configYml["default"].discovery.publish.sub + "'");
  zmq_discovery.connect(url_publisher);
  zmq_discovery.subscribe(_configYml["default"].discovery.publish.sub);
  zmq_discovery.on("message", function (data) {
    var dataObj = JSON.parse(data.toString());
    console.log(dataObj);

    if (dataObj.action === "add") {
      _configureStore["default"].dispatch(zmqBroker.onZeroMQAdd(dataObj.zmq, _server["default"].wss));
    } else if (dataObj.action === "rm") {
      _configureStore["default"].dispatch(zmqBroker.onZeroMQSubRemoveByGroup(dataObj.zmq));

      _configureStore["default"].dispatch(zmqBroker.onZeroMQRemove(dataObj.zmq, _server["default"].wss));
    } else {
      console.log("Error : [zmq_discovery] unknown type=" + dataObj.type);
    }
  });
}

var myVar = setInterval(myTimer, process.env.ZMQ2WS_INACTIVITY_CHECK_MSEC || 60 * 1000
/** 1 min */
);

function myTimer() {
  _configureStore["default"].dispatch(zmqBroker.onZeroMQSubCleanup(process.env.ZMQ2WS_INACTIVITY_TIMEOUT_SEC || 3600
  /** 1 hour */
  , _server["default"].wss));
}

_configureStore["default"].dispatch(appInfo.onAppStart({
  name: _package.name,
  version: _package.version
}));

_server["default"].server.listen(_server["default"].get("port"), function () {
  return console.log("Http" + (_configYml["default"].zmq2ws.ssl.enabled ? "s" : "") + " is listening on port " + _server["default"].get("port"));
});

process.on("SIGINT", function () {
  console.log();
  console.log("Exiting ...");
  zmq_discovery.unsubscribe(_configYml["default"].discovery.publish.sub);
  zmq_discovery.unbind(url_publisher);
  process.exit(1);
});